<?php
  define("GRES_ST_START",  0);
  define("GRES_ST_INRES",  1);
  define("GRES_ST_INERR",  2);
  define("GRES_ST_FINISH", 3);

class gimp {
  var $sockname;
  var $sock = false;
  var $debug = false;

  var $f_fontname;
  var $f_size;
  var $f_size_type;
  var $f_antialias;
  var $f_border;

  function gimp($sockname_in)
  {
    $this->sockname = $sockname_in;
  }

  function open_connection()
  {    
    if (($this->sock = fsockopen($this->sockname, 0, $errno, $errstr, 5))
	== false) {
      if ($this->debug)
	printf("Gimp class: open socket failed [%d] [%s]<br>\n",
	       $errno, $errstr);
      return (false);
    }
    else
      return (true);
  }

  function close_connection()
  {    
    if ($this->sock)
      fclose($this->sock);
  }

  function file_load($fname)
  {
    fwrite($this->sock, "(gimp-file-load RUN-NONINTERACTIVE \"".$fname."\" \"".$fname."\")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      if ($this->debug)
	printf("Gimp class: file_load failed (%s)<br>\n", $fname);
      
      return (false);
    }

    // l'handle e':
    return ($this->gimp_to_int($ret));
  }

  function xcf_save($img, $fname)
  {
    fwrite($this->sock, "(gimp-xcf-save 0 $img (car (gimp-image-get-active-layer ".$img.")) \"$fname\" \"$fname\")\n");

    
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    
    return (true);
  }
  
  function jpeg_save($img, $fname)
  {
    fwrite($this->sock, 
"(file-jpeg-save RUN-NONINTERACTIVE $img (car (gimp-image-get-active-layer ".$img.")) \"$fname\" \"$fname\" .9 .5 0 0 \"Build with gimpbot\" 0 0 0 1)\n");
    
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    
    return (true);
  }

  function image_width($img)
  {
    fwrite($this->sock, "(gimp-image-width ".$img.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      if ($this->debug)
	printf("Gimp class: image_width failed (%d)<br>\n", $img);
      
      return (false);
    }

    // la larghezza e':
    return ($this->gimp_to_int($ret));
  }

  function image_height($img)
  {
    fwrite($this->sock, "(gimp-image-height ".$img.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      if ($this->debug)
	printf("Gimp class: image_heigth failed (%d)<br>\n", $img);
      
      return (false);
    }

    // la larghezza e':
    return ($this->gimp_to_int($ret));
  }

  function image_duplicate($img)
  {
    fwrite($this->sock, "(gimp-image-duplicate ".$img.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      if ($this->debug)
	printf("Gimp class: image_duplicate failed (%d)<br>\n", $img);
      
      return (false);
    }

    // la nuova immagine e':
    return ($this->gimp_to_int($ret));
  }

  function image_delete($img)
  {
    fwrite($this->sock, "(gimp-image-delete ".$img.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      if ($this->debug)
	printf("Gimp class: image_delete failed (%d)<br>\n", $img);
      
      return (false);
    }

    return (true);
  }

  function image_crop($img, $w, $h, $x, $y)
  {
    fwrite($this->sock, "(gimp-image-crop ".$img." ".$w." ".$h." ".$x." ".$y.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      if ($this->debug)
	printf("Gimp class: image_heigth failed (%d)<br>\n", $img);
      
      return (false);
    }

    return (true);
  }

  function image_scale($img, $w, $h)
  {
    fwrite($this->sock, "(gimp-image-scale ".$img." ".$w." ".$h.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      if ($this->debug)
	printf("Gimp class: image_heigth failed (%d)<br>\n", $img);
      
      return (false);
    }

    return (true);
  }
  
  function image_get_active_layer($img)
  {
    fwrite($this->sock, "(gimp-image-get-active-layer ".$img.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
     
      return (false);
    }
    return ($this->gimp_to_int($ret));
  }

  function image_merge_down($img, $lay, $mode)
  {
    fwrite($this->sock, sprintf("(gimp-image-merge-down %d %d %s)\n",
				$img, $lay, $mode));
    if (($ret = $this->read_result($this->sock)) == false) {
     
      return (false);
    }
    return (true);
  }

  function image_set_active_layer($img, $lay)
  {
    fwrite($this->sock, sprintf("(gimp-image-set-active-layer %d %d)\n",
				$img, $lay, $mode));
    if (($ret = $this->read_result($this->sock)) == false) {
     
      return (false);
    }
    return (true);
  }

  function layer_new($img,$w,$h,$type,$name,$opacity,$mode)
  {
    fwrite($this->sock, sprintf("(gimp-layer-new %d %d %d %s \"%s\" %d %s)\n",
				$img, $w, $h, $type, $name, $opacity, $mode));
    if (($ret = $this->read_result($this->sock)) == false) {
      if ($this->debug)
	printf("Gimp class: new layer<br>\n");
      
      return (false);
    }
    
    // la larghezza e':
    return ($this->gimp_to_int($ret));
  }
  function layer_copy($lay,$add_alpha)
  {
    
    fwrite($this->sock, "(gimp-layer-copy ".$lay." ".($add_alpha ? "1" : "0").")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    return ($this->gimp_to_int($ret));
  }

  function edit_copy($lay)
  {    
    fwrite($this->sock, "(gimp-edit-copy ".$lay.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }

    if (($iret = $this->gimp_to_int($ret)) == 0)
      return (false);
    else
      return (true);
  }

  function edit_paste($lay)
  {    
    fwrite($this->sock, "(gimp-edit-paste ".$lay." 0)\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    
    return ($this->gimp_to_int($ret));
  }

  function edit_clear($drw)
  {    
    fwrite($this->sock, "(gimp-edit-clear ".$drw.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    
    return (true);
  }

  function floating_sel_anchor($fsel)
  {    
    fwrite($this->sock, "(gimp-floating-sel-anchor  ".$fsel.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    
    return (true);
  }

  function server_get_canvas_id()
  {
    fwrite($this->sock, "(gimp-server-get-canvas-id)\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    return ($this->gimp_to_int($ret));
  }


  function server_get_mask_lid()
  {
    fwrite($this->sock, "(gimp-server-get-mask-lid)\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    return ($this->gimp_to_int($ret));
  }

  function layer_to_gray($lay)
  {
    fwrite($this->sock, "(gimp-hue-saturation $lay ALL-HUES 0 70 -100)\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    fwrite($this->sock, "(gimp-hue-saturation $lay ALL-HUES 0 70 -100)\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    return (true);
  }

  function server_transact_begin()
  {
    fwrite($this->sock, "(gimp-server-transact-begin)\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }

    return (true);
  }

  function server_transact_finish()
  {
    fwrite($this->sock, "(gimp-server-transact-finish)\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }

    return (true);
  }


  // $inittype enum:
  //    WHITE          (full opaque mask)
  //    BLACK          (full transparent mask)
  //    ALPHA          (copy of alpha chan of the layer)
  //    ALPHA-TRANSFER (move of alpha chan of the layer)
  //    SELECTION      (alpha chan of the selection)
  //    COPY           (gray vers of the selection)
  function layer_create_mask($lay,$inittype)
  {
    
    fwrite($this->sock, "(gimp-layer-create-mask ".$lay." ADD-".$inittype."-MASK)\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    return ($this->gimp_to_int($ret));
  }

  function layer_add_mask($lay,$mask)
  {
    
    fwrite($this->sock, "(gimp-layer-add-mask ".$lay." ".$mask.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    return (true);
  }

  // $action enum:
  //    APPLY          (apply mask)
  //    DISCARD        (discard mask)
  function layer_remove_mask($lay,$action)
  {
    
    fwrite($this->sock, "(gimp-layer-remove-mask ".$lay." MASK-".$action.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    return (true);
  }

  function image_get_layers($img)
  {
    fwrite($this->sock, "(gimp-image-get-layers ".$img.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    return ($this->gimp_to_array_l2($ret));
  }
  
  function drawable_get_name($drw)
  {
    fwrite($this->sock, "(gimp-drawable-get-name ".$drw.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    return ($this->gimp_to_string($ret));
  } 
  
  function image_get_layer_by_name($img, $name)
  {
    if (($ar = $this->image_get_layers($img)) == false)
      return (false);

    $ct = count($ar);

    // printf("COUNT $ct<br>\n");
    // exit;

    for ($i = 0 ; $i < $ct ; $i++) {
      if ($this->drawable_get_name($ar[$i]) == $name)
	return ($ar[$i]);
    }
    return (false);
  }

  function rect_select_simple($img, $x, $y, $w, $h)
  {
    fwrite($this->sock, "(gimp-rect-select ".$img." ".$x." ".$y." ".$w." ".$h." CHANNEL-OP-ADD 0 0)\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      
      return (false);
    }

    return (true);
  }
    
  function image_flatten($img)
  {    
    fwrite($this->sock, "(gimp-image-flatten ".$img.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    
    return ($this->gimp_to_int($ret));
  }



  function plug_in_dog($img, $lay, $inner, $outer, $norm, $invert)
  {    
    fwrite($this->sock, sprintf("(plug-in-dog RUN-NONINTERACTIVE %d %d %d %d %d %d)\n",
				$img, $lay, $inner, $outer,
				($norm ? 1 : 0), ($invert ? 1 : 0)));

    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }

    return (true);
  }

  // $stack_pos == -1 -> top
  // $stack_pos == 0  -> bottom
  function image_add_layer($img, $lay, $stack_pos)
  {
    fwrite($this->sock, "(gimp-image-add-layer ".$img." ".$lay." ".$stack_pos.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      
      return (false);
    }

    return (true);
  }

  //
  //  mode FOREGROUND, BACKGROUND, WHITE, TRANSPARENT, PATTERN
  function drawable_fill($drw,$mode)
  {
    fwrite($this->sock, "(gimp-drawable-fill ".$drw." ".$mode."-FILL)\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      
      return (false);
    }

    return (true);
  } 

  function layer_set_offsets($lay,$x,$y)
  {
    fwrite($this->sock, "(gimp-layer-set-offsets ".$lay." ".$x." ".$y.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      
      return (false);
    }

    return (true);
  }

  function layer_translate($lay,$x,$y)
  {
    fwrite($this->sock, "(gimp-layer-translate ".$lay." ".$x." ".$y.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      
      return (false);
    }

    return (true);
  }

  function selection_float($dra,$x,$y)
  {
    fwrite($this->sock, "(gimp-selection-float ".$dra." ".$x." ".$y.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      
      return (false);
    }

    return (true);
  }

  function drawable_offsets($dra)
  {
    fwrite($this->sock, "(gimp-drawable-offsets ".$dra.")\n");
    if (($ret = $this->read_result($this->sock)) == false) {
      
      return (false);
    }

    return (true);
  }

  function drawable_offset($dra, $wrap, $fill, $x, $y)
  {
    fwrite($this->sock, sprintf("(gimp-drawable-offset %d %d %d %d %d);\n",
				$dra, $wrap, $fill, $x, $y));
    if (($ret = $this->read_result($this->sock)) == false) {
      
      return (false);
    }

    return (true);
  }

  //
  //  FONT AND TEXT FUNCTIONS

  // size_type enum: "PIXELS", "POINTS"
  function set_font($fontname, $size, $size_type, $antialias, $border)
  {
    $this->f_fontname = $fontname;
    $this->f_size = $size;
    $this->f_size_type = $size_type;
    $this->f_antialias = $antialias;
    $this->f_border = $border;

    return (true);
  }

  function text_get_extents($text)
  {
    fwrite($this->sock, sprintf("(gimp-text-get-extents-fontname \"%s\" %d %s \"%s\")\n",
				$text,	$this->f_size, $this->f_size_type,
				$this->f_fontname));
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    
    return ($this->gimp_to_array($ret));
    
  }
  
  function text($img, $drw, $x, $y, $text)
  {    
    fwrite($this->sock, sprintf("(gimp-text-fontname %d %d %d %d \"%s\" %d %s %d %s \"%s\")\n",
				$img, $drw, $x, $y, $text,
				$this->f_border, ($this->f_antialias ? "TRUE" : "FALSE"), 
				$this->f_size, $this->f_size_type,
				$this->f_fontname));
    if (($ret = $this->read_result($this->sock)) == false) {
      return (false);
    }
    
    return ($this->gimp_to_int($ret));
  }

  function text_ptsw_maxwidth($img, $drw, $x, $y, $text, $wmax, $sz_end)
  {
    $oldsize = $this->f_size;
    
    if ($sz_end >= $this->f_size)
      return (false);

    for ($i = $this->f_size ; $i >= $sz_end ; $i--) {
      $this->f_size = $i;
      $box = $this->text_get_extents($text);
      if ($box[0] <= $wmax)
	break;
    }
    if ($i == $sz_end) {
      $this->f_size = $oldsize;
      return (false);
    }

    $ret = $this->text($img, $drw, $x, $y-$box[2], $text);
    
    $this->f_size = $oldsize;
    return ($ret);
  }


  // 
  //  UTILITY FUNCTIONS
  //
  function read_result()
  {

    while ($st != GRES_ST_FINISH) {
      $st = GRES_ST_START;

      $startres = -1;
      if (($curet = fread($this->sock, 10240)) == "")
	break;

      $ret .=  $curet;

      // printf("RET [%s]<br>\n", $ret);
      for ($cur = 0, $ctpar = 0 ; $cur < strlen($ret) ; $cur++) {
	// printf("ST[%d] [%s] [%d]<br>\n", $st, substr($ret,$cur,1),$ctpar);
	if ($st == GRES_ST_START) {
	  if (substr($ret,$cur,5) == "ERROR") {
	    $st = GRES_ST_FINISH;
	  }	  
	  else if (substr($ret,$cur,1) == "(") {
	    $startres = $cur;
	    $st = GRES_ST_INRES;
	    $ctpar++;
	  }
	}

	else if ($st == GRES_ST_INRES) {
	  if (substr($ret,$cur,1) == "(") 
	    $ctpar++;
	  else if (substr($ret,$cur,1) == ")") 
	    $ctpar--;

	  if ($ctpar == 0) {
	    $finishres = $cur - $startres + 1;
	    $st = GRES_ST_FINISH;
	    break;
	  }
	}
      }
    }
    
    if ($st == GRES_ST_FINISH) {
      if ($startres == -1)
	return ("ERROR");
      else
	return (substr($ret, $startres, $finishres));
    }
    else 
      return (false);
  }
  
  function gimp_to_int($s)
  {
    for ($i = 0 ; $i < strlen($s) ; $i++) {
      $c = substr($s,$i,1);
      if (strstr("0123456789+-", $c) != false)
	break;
    }
    
    return ((int)substr($s,$i));
  }

  function gimp_to_array($s)
  {
    for ($i = 0 ; $i < strlen($s) ; $i++) {
      $c = substr($s,$i,1);
      if (strstr("( \n", $c) == false)
	break;
    }
    $ss = substr($s,$i);
    // echo "SS [$ss]<br>\n";
    for ($i = 0 ; $i < strlen($ss) ; $i++) {
      $c = substr($ss,$i,1);
      if (strstr(")", $c) != false)
	break;
    }
    $sss = substr($ss,0,$i);
    // echo "SSS [$sss]<br>\n";
    
    return (explode(" ", $sss));
  }

  function gimp_to_array_l2($s)
  {

    // printf("S [$s]<br>\n");
 

    for ($i = 0 ; $i < strlen($s) ; $i++) {
      $c = substr($s,$i,1);
      if (strstr("(", $c) != false)
	break;
    }
    $s2 = substr($s,$i+1);
    // echo "S2 [$s2]<br>\n";
 
    for ($i = 0 ; $i < strlen($s2) ; $i++) {
      $c = substr($s2,$i,1);
      if (strstr("#", $c) != false)
	break;
    }
    $s3 = substr($s2,$i+1);
    // echo "S3 [$s3]<br>\n";
    
    for ($i = 0 ; $i < strlen($s3) ; $i++) {
      $c = substr($s3,$i,1);
      if (strstr("( \n", $c) == false)
	break;
    }
    $s4 = substr($s3,$i);

    // echo "S4 [$s4]<br>\n";
    for ($i = 0 ; $i < strlen($s4) ; $i++) {
      $c = substr($s4,$i,1);
      if (strstr(")", $c) != false)
	break;
    }
    $s5 = substr($s4,0,$i-1);
    // echo "S5 [$s5]<br>\n";
    
    return (explode(" ", $s5));
  }

  function gimp_to_string($s)
  {
    $st = 0;
    $ret = "";
    for ($i = 0 ; $i < strlen($s) ; $i++) {
      $c = substr($s,$i,1);
      switch ($st) {
      case 0:
	if ($c == "(")
	  $st = 1;
	break;
      case 1:
	if ($c == '"')
	  $st = 2;
	break;
      case 2:
	if ($c == '\\')
	  $st = 3;
	else if ($c == '"')
	  $st = 4;
	else
	  $ret .= $c;
	break;
      case 3:
	$ret .= $c;
	$st = 2;
	break;
      default:
	break;
      }
      if ($st == 4)
	break;
    }
    if ($st == 4)
      return ($ret);
    else
      return (false);
  }
} // class gimp end
?>